write.nex <- function (dist, filename = NULL) 
{
    if (is.null(filename)) 
        filename = paste(deparse(substitute(dist)), ".tab", sep = "")
    # print(filename)
    	# clean up object names (SplitsTree only accepts accent-free characters,  and only periods as non-characters)
    attr(dist, "Labels") <- gsub("[[:punct:]]", ".", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("[[:space:]]", ".", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("á", "a", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("à", "a", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("â", "a", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ã", "a", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("é", "e", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("è", "e", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ê", "e", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ẽ", "e", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("í", "i", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ì", "i", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("î", "i", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ĩ", "i", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ó", "o", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ò", "o", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("ô", "o", attr(dist, "Labels"))
    attr(dist, "Labels") <- gsub("õ", "o", attr(dist, "Labels"))
    # this list may have to be expanded. For now it's OK
    
    # open the file connection:
    handle <- file(filename, "wt")
    
    # nexus format contains 5 spaces followed by the number of taxa:
    write(paste("     ", attr(dist, "Size"), sep = ""), file = handle, 
        sep = "")
    suppressWarnings(write.table(as.matrix(dist), file = handle, append = T, sep = "\t"))
    close(handle)
    
    # post-processing: remove the object names in the horizontal; they are in line 2. And remove the quotes.	
    system(paste("cat ", filename, " | sed -e '2 d' | sed -e 's/\\\"//g' > nex.", filename, sep="")) 
    system(paste("rm ", filename)) 
}
